/*
 *      gen.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gen.h"

static Word     Mem[MVM_MAXPROGLEN];

Address         CurrentPC;

/* PutInst(): CurrentPC ΰ֤˻ꤵ줿̿CurrentPC 
	      ʤ롣 */

void PutInst(Word op, Word i, Word j, SWord dk)
{
    long waddr = CurrentPC / sizeof(Word);
    
    CurrentPC += sizeof(Word);
    switch (op) {
	case MVM_LD: case MVM_ST: case MVM_LDB: case MVM_LDUB: case MVM_STB:
	    Mem[waddr] = (op << 24) | (i << 24) | (j << 20) | (dk & 0xfffff);
	    break;
	case MVM_LDI: case MVM_LDHI: case MVM_POP: case MVM_PUSH:
	case MVM_CALL: case MVM_JPL: case MVM_IN: case MVM_OUT:
	case MVM_INQ: case MVM_OUTQ: case MVM_OUTS: case MVM_EXIT:
	case MVM_JP: case MVM_JPE: case MVM_JPNE:
	case MVM_JPGT: case MVM_JPLE: case MVM_JPLT: case MVM_JPGE:
	case MVM_JPGTU: case MVM_JPLEU: case MVM_JPC: case MVM_JPNC:
	case MVM_JPNEG: case MVM_JPNNEG: case MVM_JPV: case MVM_JPNV:
	    Mem[waddr] = (op << 24) | (i << 20) | (dk & 0xfffff);
	    break;
	case MVM_ADD: case MVM_ADDC: case MVM_SUB: case MVM_SUBC:
	case MVM_AND: case MVM_OR: case MVM_XOR: case MVM_NXOR:
	case MVM_SLL: case MVM_SRL: case MVM_SRA:
	case MVM_ADDI: case MVM_ADDIC: case MVM_SUBI: case MVM_SUBIC:
	case MVM_ANDI: case MVM_ORI: case MVM_XORI: case MVM_NXORI:
	case MVM_SLLI: case MVM_SRLI: case MVM_SRAI:
	case MVM_MUL: case MVM_DIV: case MVM_MOD:
	case MVM_MULU: case MVM_DIVU: case MVM_MODU:
	    Mem[waddr] = (op << 24) | (i << 20) | (j << 16) | (dk & 0xffff);
	default:
	    break;
    }
}

/* FixInst(): ꤵ줿֤̿Υɥ쥹ʬ(20bit)롣 */

void FixInst(Address pc, Address d)
{
    long waddr = pc / sizeof(Word);

    Mem[waddr] = (Mem[waddr] & ~0xfffff) | d;
}

/* FixInstChain(): ꤵ줿֤ϤꥹȤ򤿤ɤʤ顢ꥹ
		   ̿Υɥ쥹ʬ(20bit)롣 */

void FixInstChain(Address pc, Address d)
{
    Address next;

    while (pc) {
	next = Mem[pc / sizeof(Word)] & 0xfffff;
	FixInst(pc, d);
	pc = next;
    }
}

void InitInst(void)
{
    CurrentPC = 0;
}

/* WriteObjectFile(): ѥΥ줿̿ե
		      Ǽ롣 */

int WriteObjectFile(char * filename)
{
    FILE *out = fopen(filename, "wb");
    long waddr;

    if (out == NULL)
	return -1;
    for (waddr = 0; waddr < CurrentPC / sizeof(Word); waddr ++) {
	putc((Mem[waddr] >> 24) & 0xff, out);
	putc((Mem[waddr] >> 16) & 0xff, out);
	putc((Mem[waddr] >> 8) & 0xff, out);
	putc(Mem[waddr] & 0xff, out);
    }
    fclose(out);
    return 0;
}
