/*
 *      gen.h
 */

#define MVM_MAXPROGLEN  (100000)

#define MVM_R0  (0)
#define MVM_R1  (1)
#define MVM_R2  (2)
#define MVM_R3  (3)
#define MVM_R4  (4)
#define MVM_R5  (5)
#define MVM_R6  (6)
#define MVM_R7  (7)
#define MVM_R8  (8)
#define MVM_R9  (9)
#define MVM_R10 (10)
#define MVM_GP  (11)
#define MVM_RA  (12)
#define MVM_FP  (13)
#define MVM_SP  (14)
#define MVM_PC  (15)

#define MVM_LD          (0x00)
#define MVM_ST          (0x10)
#define MVM_LDB         (0x20)
#define MVM_LDUB        (0x30)
#define MVM_STB         (0x40)
#define MVM_LDI         (0x80)
#define MVM_LDHI        (0x81)
#define MVM_POP         (0x82)
#define MVM_PUSH        (0x83)
#define MVM_CALL        (0x84)
#define MVM_JPL         (0x85)
#define MVM_IN          (0x88)
#define MVM_OUT         (0x89)
#define MVM_INQ         (0x8a)
#define MVM_OUTQ        (0x8b)
#define MVM_OUTS        (0x8c)
#define MVM_EXIT        (0x8f)
#define MVM_JP          (0x90)
#define MVM_JPE         (0x92)
#define MVM_JPNE        (0x93)
#define MVM_JPGT        (0x94)
#define MVM_JPLE        (0x95)
#define MVM_JPLT        (0x96)
#define MVM_JPGE        (0x97)
#define MVM_JPGTU       (0x98)
#define MVM_JPLEU       (0x99)
#define MVM_JPC         (0x9a)
#define MVM_JPNC        (0x9b)
#define MVM_JPNEG       (0x9c)
#define MVM_JPNNEG      (0x9d)
#define MVM_JPV         (0x9e)
#define MVM_JPNV        (0x9f)
#define MVM_ADD         (0xa0)
#define MVM_ADDC        (0xa1)
#define MVM_SUB         (0xa2)
#define MVM_SUBC        (0xa3)
#define MVM_AND         (0xa4)
#define MVM_OR          (0xa5)
#define MVM_XOR         (0xa6)
#define MVM_NXOR        (0xa7)
#define MVM_SLL         (0xa8)
#define MVM_SRL         (0xa9)
#define MVM_SRA         (0xaa)
#define MVM_ADDI        (0xb0)
#define MVM_ADDIC       (0xb1)
#define MVM_SUBI        (0xb2)
#define MVM_SUBIC       (0xb3)
#define MVM_ANDI        (0xb4)
#define MVM_ORI         (0xb5)
#define MVM_XORI        (0xb6)
#define MVM_NXORI       (0xb7)
#define MVM_SLLI        (0xb8)
#define MVM_SRLI        (0xb9)
#define MVM_SRAI        (0xba)
#define MVM_MUL         (0xc0)
#define MVM_DIV         (0xc1)
#define MVM_MOD         (0xc2)
#define MVM_MULU        (0xc4)
#define MVM_DIVU        (0xc5)
#define MVM_MODU        (0xc6)

typedef unsigned long   Word;
typedef long            SWord;
typedef long            Offset;
typedef unsigned long   Address;

extern Address  CurrentPC;
extern void     PutInst(Word op, Word i, Word j, SWord dk);
extern void     FixInst(Address pc, Word d);
extern void     FixInstChain(Address pc, Word d);
extern void     InitInst(void);
extern int      WriteObjectFile(char * filename);

