
#define TRUE    1
#define FALSE   0

extern void *   malloc();

typedef struct {
    unsigned char       f;
    unsigned char       l;
    unsigned short      a;
} Instruction;

extern Instruction      code[];

extern void             InitGenerator();
extern void             Gen();
extern unsigned int     Label();
extern void             fixup();

#define VM0_LIT         0
#define VM0_OPR         1
#define VM0_LOD         2
#define VM0_STO         3
#define VM0_CAL         4
#define VM0_INT         5
#define VM0_JMP         6
#define VM0_JPC         7

#define VM0_RET         0
#define VM0_MINUS       1
#define VM0_ADD         2
#define VM0_SUB         3
#define VM0_MUL         4
#define VM0_DIV         5
#define VM0_ODD         6
#define VM0_NOP         7
#define VM0_EQ          8
#define VM0_NEQ         9
#define VM0_LT          10
#define VM0_GE          11
#define VM0_GT          12
#define VM0_LE          13
#define VM0_IN          14
#define VM0_OUT         15

typedef enum {
    pl0null, pl0odd, pl0times, pl0div, pl0plus,
    pl0minus, pl0eql, pl0neq, pl0lss, pl0leq,
    pl0gtr, pl0geq, pl0comma, pl0rparen, pl0then,
    pl0do, pl0lparen, pl0becomes, pl0number, pl0ident,
    pl0semicolon, pl0end, pl0call, pl0if, pl0while,
    pl0begin, pl0read, pl0write, pl0const, pl0var,
    pl0procedure, pl0period, pl0eof
} Symbol;

extern Symbol           sym;
extern unsigned int     id;
extern unsigned int     num;
extern FILE             *source;
extern int              line;

extern void             InitScanner();
extern int              Diff();
extern void             KeepId();
extern void             GetSym();

extern void             parse();
