/*
 *      parse0.c
 */

#include <stdio.h>
#include <stdlib.h>
#include "scan.h"

static void Exp(void);
static void Block(void);

static void FunArgs(void)
{
    if (token != mc_lparen)
	Error("ؿƽФΰꥹȤ ( ޤ");
    GetToken();
    if (token != mc_rparen) {
	Exp();
	while (token == mc_comma) {
	    GetToken();
	    Exp();
	}
	if (token != mc_rparen)
	    Error("ؿƽФΰꥹȤ ) ޤ");
    }
    GetToken();
}

static void Factor(void)
{
    switch (token) {
    case mc_ident:
	/* ѿ: <Ident>ޤϡؿƤӽФ: <Ident> <FunArgs> */
	GetToken();
	if (token == mc_lparen)
	    FunArgs();
	break;
    case mc_number:
	/* : <Number> */
	GetToken();
	break;
    case mc_lparen:
	/* ̤ǰϤޤ줿: ( <Exp> ) */
	GetToken();
	Exp();
	if (token == mc_rparen)
	    GetToken();
	else
	    Error("Ĥ̤٤֤ˤޤ");
	break;
    default:
	Error("ʸˡ꤬ޤ");
	break;
    }
}

static void Term(void)
{
    Factor();
    while (token == mc_mult || token == mc_div || token == mc_mod) {
	GetToken();
	Factor();
    }
}

static void Exp(void)
{
    if (token == mc_plus || token == mc_minus) {
	GetToken();
	Term();
    }
    else
	Term();
    while (token == mc_plus || token == mc_minus) {
	GetToken();
	Term();
    }
}

static void Cond(void)
{
    Exp();
    if (mc_eq <= token && token <= mc_ge) {
	GetToken();
	Exp();
    }
    else
	Error("Ｐʸˡ꤬ޤ");
}

static void Statement(void)
{
    switch (token) {
    case mc_ident:
	/* <Ident> = <Exp>; | <Ident> <FunArgs>; */
	GetToken();
	switch (token) {
	case mc_assign:
	    GetToken();
	    Exp();
	    if (token != mc_semicolon)
		Error("ʸ ; ޤ");
	    GetToken();
	    break;
	case mc_lparen:
	    FunArgs();
	    if (token != mc_semicolon)
		Error("ؿƽФʸ ; ޤ");
	    GetToken();
	    break;
	default:
	    Error("ʸ =ޤϡؿƽФʸ ( ޤ");
	    break;
	}
	break;
    case mc_return:
	/* return <Exp>; */
	GetToken();
	Exp();
	if (token != mc_semicolon)
	    Error("return ʸ ; ޤ");
	GetToken();
	break;
    case mc_input:
	/* input <Ident>; */
	GetToken();
	if (token != mc_ident)
	    Error("input ʸѿ̾ޤ");
	GetToken();
	if (token != mc_semicolon)
	    Error("input ʸ ; ޤ");
	GetToken();
	break;
    case mc_print:
	/* print <Exp>; */
	GetToken();
	Exp();
	if (token != mc_semicolon)
	    Error("print ʸ ; ޤ");
	GetToken();
	break;
    case mc_if:
	/* if ( <Cond> ) <Statement> [ else <Statement> ] */
	GetToken();
	if (token != mc_lparen)
	    Error("if θ ( ޤ");
	GetToken();
	Cond();
	if (token != mc_rparen)
	    Error("if ξＰθ ) ޤ");
	GetToken();
	Statement();
	if (token == mc_else) {
	    GetToken();
	    Statement();
	}
	break;
    case mc_while:
	/* while ( <Cond> ) <Statement> */
	GetToken();
	if (token != mc_lparen)
	    Error("while θ ( ޤ");
	GetToken();
	Cond();
	if (token != mc_rparen)
	    Error("while ξＰθ ) ޤ");
	GetToken();
	Statement();
	break;
    case mc_lcb:
	/* "{" [ <VarDef> ] { <Statement> } "}" */
	Block();
	break;
    case mc_semicolon:
	Error("ʸϵƤޤ");
	break;
    default:
	Error("ʸϤ٤˸꤬ޤ");
	break;
    }
}

static void VarDef(void)
{
    GetToken();
    if (token != mc_ident)
	Error("ѿ̾ޤ");
    GetToken();
    while (token == mc_comma) {
	GetToken();
	if (token == mc_ident)
	    GetToken();
    }
    if (token != mc_semicolon)
	Error("ѿ ,  ; ޤ");
    GetToken();
}

static void FunDef(void)
{
    GetToken();
    if (token != mc_lparen)
	Error("ؿΰꥹȤ ( ޤ");
    GetToken();
    if (token != mc_rparen) {
	if (token != mc_ident)
	    Error("ؿΰꥹȤʸˡ꤬ޤ");
	GetToken();
	while (token == mc_comma) {
	    GetToken();
	    if (token != mc_ident)
		Error("ؿΰꥹȤʸˡ꤬ޤ");
	    GetToken();
	}
	if (token != mc_rparen)
	    Error("ؿΰꥹȤ ) ޤ");
    }
    GetToken();
    Block();
}

static void Block(void)
{
    GetToken();
    if (token == mc_int)
	VarDef();
    while (token != mc_rcb)
	Statement();
    GetToken();
}

static void Prog(void)
{
    while (token == mc_int || token == mc_ident) {
	if (token == mc_int)
	    VarDef();
	else
	    FunDef();
    }
}

void Parse(void)
{
    GetToken();
    Prog();
    if (token != mc_eof)
	Error("ѿؿȤǧǤޤ");
}

int main (int argc, char *argv[])
{
    if (argc < 2) {
	fprintf(stderr, "ե뤬ꤵƤޤ\n");
	exit(1);
    }
    if (OpenFile(argv[1]) != 0) {
	fprintf(stderr, "եɤ߹ळȤǤޤ\n");
	exit(1);
    }
    Parse();
    CloseFile();
    return 0;
}

